#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
A simple script for fixing the JSON encoding of JSCore.

Example usage: python jscore.py example.hcj
"""
from __future__ import print_function
import sys
import json


def main(path):
    with open(path, 'r') as f:
        decoded = json.load(f)
    print(json.dumps(decoded, indent=2))


if __name__ == '__main__':
    if len(sys.argv) < 2:
        print("Error, missing path of input file.")
        print(__doc__)
        sys.exit(2)

    main(sys.argv[1])
