# -*- coding: utf-8 -*-
from pyhaskell.interpreter.module import CoreMod, expose_var
from pyhaskell.interpreter.haskell import (
    Value, make_constructor, make_application, Symbol)


mod = CoreMod("base:GHC.Base")


@expose_var(mod, "++", [Value, Value])
def concatenation(a, b):
    """List concatenation, ++ operator."""
    stack = []
    current = a
    while current.numargs() > 0:
        stack.append(current.getarg(0))
        current = current.getarg(1)

    cons = Symbol.get_symbol(":")
    current = b
    for i in range(len(stack) - 1, -1, -1):
        current = make_constructor(cons, [stack[i], current])
    return current


@expose_var(mod, "$", [Value, Value])
def zd(a, b):
    """Non-strict application operator: $"""
    return make_application(a, [b])


# Function 1 is evaluated before function 2 (>>)
#@mod.expose(">>", [Value, Value])
#def s(a, b):
#    f2 = function(">>", [([Var("_")], b)])
#    app = make_application(b, [a])
#    return app


class IO(Value):
    _immutable_fields_ = ["value"]

    def __init__(self, a):
        self.value = a

    def tostr(self):
        return str(self.value)


mod.qvars["$fMonadIO"] = IO("()")
