# -*- coding: utf-8 -*-
from pyhaskell.interpreter.module import CoreMod, expose_var
from pyhaskell.interpreter.haskell import make_constructor, Symbol
from pyhaskell.interpreter.primtype import Char, Addr


mod = CoreMod("ghc-prim:GHC.CString")


@expose_var(mod, "unpackCString#", [Addr])
def unpackCString(a):
    """Convert an Addr (Python string) into a Haskell list of chars."""
    current = make_constructor(Symbol.get_symbol("[]"), [])
    cons = Symbol.get_symbol(":")
    str_ = a.tostr()
    for i in range(len(str_) - 1, -1, -1):
        current = make_constructor(cons, [Char(str_[i]), current])
    return current
