# -*- coding: utf-8 -*-
from pyhaskell.interpreter import prim
from pyhaskell.interpreter.haskell import make_application, Value
from pyhaskell.interpreter.module import CoreMod, expose_var, get_var
from pyhaskell.interpreter.primtype import Int


mod = CoreMod("base:GHC.Num")
mod.qvars["$fNumInt"] = Int(1)

mod2 = CoreMod("base:GHC.Real")
mod2.qvars["$fIntegralInt"] = Int(9)


@expose_var(mod2, "div", [Int, Value, Value])
def division(ty, a, b):
    if ty == get_var(mod2, "$fIntegralInt"):
        return make_application(prim.divide, [a, b])
    else:
        raise NotImplementedError


# (-)
@expose_var(mod, "-", [Int, Value, Value])
def subtract(ty, a, b):
    if ty == get_var(mod, "$fNumInt"):
        return make_application(prim.subtract, [a, b])
    else:
        raise NotImplementedError


# (*)
@expose_var(mod, "*", [Int, Value, Value])
def multiply(ty, a, b):
    if ty == get_var(mod, "$fNumInt"):
        return make_application(prim.multiply, [a, b])
    else:
        raise NotImplementedError


# (+)
@expose_var(mod, "+", [Int, Value, Value])
def add(ty, a, b):
    if ty == get_var(mod, "$fNumInt"):
        return make_application(prim.add, [a, b])
    else:
        raise NotImplementedError
