# -*- coding: utf-8 -*-
from pyhaskell.interpreter.haskell import (
    evaluate_hnf, make_application, Constructor, Symbol)
from pyhaskell.interpreter.primtype import Int
from pyhaskell.builtin import create_list, check_same_list

from pyhaskell.builtin.hslist import take, length, replicate


def test_take():
    lst = create_list(list(range(10)))
    x = evaluate_hnf(make_application(take, [Int(4), lst]))
    assert isinstance(x, Constructor)
    assert x.numargs() == 2
    assert x.symbol == Symbol.get_symbol(":")
    assert check_same_list(x, create_list([0, 1, 2, 3]))
    assert not check_same_list(x, create_list([0, 1, 2, 3, 4]))


def test_length():
    lst = create_list(list(range(11)))
    x = evaluate_hnf(make_application(length, [lst]))
    assert isinstance(x, Int)
    assert x.value == 11


def test_replicate():
    a = Int(3)
    b = Int(99)
    x = evaluate_hnf(make_application(replicate, [a, b]))
    assert isinstance(x, Constructor)
    assert x.numargs() == 2
    assert x.symbol == Symbol.get_symbol(":")
    assert x.getarg(1).getarg(0) == b
    lst = create_list([99, 99, 99])
    assert check_same_list(x, lst)
