# -*- coding: utf-8 -*-
from pyhaskell.interpreter.module import CoreMod, expose_data_constr
from pyhaskell.interpreter.primtype import Char, Int
from pyhaskell.interpreter.haskell import (
    AbstractFunction, Symbol, Value,
    evaluate_hnf, make_application, make_constructor)


mod = CoreMod("ghc-prim:GHC.Types")


mod.add_data_constr("IO", 0)
mod.add_data_constr("[]", 0)
mod.add_data_constr("()", 0)
mod.add_primitive_alias("C#", Char)
mod.add_primitive_alias("I#", Int)


@expose_data_constr(mod, ":", [Value, Value])
def cons(a, b):
    """Cons operator ':', for creating lists."""
    # TODO: Is this a sign of a wrong implementation somewhere else?
    # b can be unevaluated if its a data constructor.
    if isinstance(b, AbstractFunction):
        b = evaluate_hnf(make_application(b, []))
    return make_constructor(Symbol.get_symbol(":"), [a, b])
