# -*- coding: utf-8 -*-
from pyhaskell.interpreter.module import CoreMod, expose_var
from pyhaskell.interpreter.haskell import make_constructor, Symbol
from pyhaskell.interpreter.primtype import true, false, Char, Int, Addr


mod = CoreMod("ghc-prim:GHC.Prim")


mod.add_primitive_alias("Char#", Char)
mod.add_primitive_alias("Int#", Int)
mod.add_primitive_alias("Addr#", Addr)


"""
# (->)
@mod.expose("(->)", [Addr, Addr])
def arrow(a, b):
    return make_constructor(Symbol.get_symbol("->"), [a, b])


@mod.expose("gtChar#", [Char, Char])
def gtChar(a0, a1):
    if a0.value > a1.value:
        return true
    else:
        return false


@mod.expose("geChar#", [Char, Char])
def geChar(a0, a1):
    if a0.value >= a1.value:
        return true
    else:
        return false


@mod.expose("eqChar#", [Char, Char])
def eqChar(a0, a1):
    if a0.value == a1.value:
        return true
    else:
        return false


@mod.expose("neChar#", [Char, Char])
def neChar(a0, a1):
    if a0.value != a1.value:
        return true
    else:
        return false
"""


# (+#)
@expose_var(mod, "+#", [Int, Int])
def add(a0, a1):
    return Int(a0.value + a1.value)


# (-#)
@expose_var(mod, "-#", [Int, Int])
def subtract(a0, a1):
    return Int(a0.value - a1.value)


# (*#)
@expose_var(mod, "*#", [Int, Int])
def multiply(a0, a1):
    return Int(a0.value * a1.value)


# (/#)
@expose_var(mod, "/#", [Int, Int])
def divide(a0, a1):
    return Int(a0.value / a1.value)
